#! /usr/bin/env python 
#coding=utf8

import os
import numpy as np
from matplotlib import rc, rcParams
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
from matplotlib.ticker import AutoMinorLocator

p = '/home/slisakov/Desktop/'
pref = ''
i=1
os.chdir(p)

def sf():
    global i

    #pdf = pref+str(i) + '.pdf'
    #ps  = pref+str(i) + '.ps'
    #plt.savefig(pdf, bbox_inches='tight')
    #os.system('pdf2ps {}'.format(pdf))  # This 'conversion' reduces
    #os.system('ps2pdf {}'.format(ps))   # file size from ~200kB to ~15kB
    #os.system('rm {}'.format(ps))
    #print(pdf, 'saved')

    #png = pref+"{:02d}".format(i)
    #plt.savefig(png, bbox_inches='tight')
    #print(png, 'saved')

    i+=1

# Оптические параметры
l=100       # ГОО           
x_lens=0    # Центр линзы
y_lens=64   # Длина линзы
hl=8
hw=4
 
# Настройка графика
lw = 1.1
ms = 4
c  = '#2266FF'
fs=14
rc('font', family='serif')
rc('font', size=fs)
rc('text', usetex=True)
fig = plt.figure()
ax = plt.subplot(111)
lim=1.4
ymax=1.5
ymin=1.2
#ax.set_ylim([-y_lens*ymin, y_lens*ymax])
#ax.set_xlim([-l*lim,      l*lim])
ax.set_xlim([-100, 120])
ax.set_ylim([-77, 72])
ax.axis('off')
ax.set_aspect('equal')
#fig.subplots_adjust(left=.15, bottom=.15, right=.95, top=.95)

# ГОО
x1 = [-l,l]
y1 = [0, 0]
ax.plot(x1, y1, 'k', lw=lw)
sf()

# Координаты источника и изображения
xs = -85
ys = 44
xi = 90
d  = -xs
h  = ys
f  = xi     # f — расстояние от линзы до изображения. Собирающая, действ. изобр.
G  = f/d    # линейное увеличение
# Расчёт F
yi = -h*G
dy = yi-ys
dx = xi
k  = dy/dx
b  = ys
x  = [0, 1.5*xi]
y  = [k*x[0]+b,  k*x[1]+b]
F = -b/k

# Предмет
ax.arrow(-d, 0, 0, h, fc='tab:blue', ec='tab:blue', head_width=hw, head_length=hl, length_includes_head=True, lw=lw)
ax.text(-d-l/30, h/2, '$h$', ha='right', va='center_baseline')
sf()

# Линза
ax.plot([x_lens,x_lens],[-y_lens,y_lens],'k',lw=lw, zorder=0)
dx=2
dy=-6
x=[x_lens,0-dx]
y=[-y_lens,-y_lens-dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens-dx]
y=[y_lens,y_lens+dy]
ax.plot(x,y,'k',lw=lw)
x=[x_lens,x_lens+dx]
ax.plot(x,y,'k',lw=lw)
sf()

# Левый фокус
ax.plot(-F,     y1[0],    'o',  ms=5, c='k')
#ax.text (-F*1.3, y1[0]-3, '$F$', horizontalalignment='right', verticalalignment='top', fontsize=fs*0.75)
# Правый фокус
ax.plot(F,     x_lens,    'o',  ms=5, c='k')
ax.text (F+l/20, x_lens+1, '$F$', horizontalalignment='left', verticalalignment='bottom', fontsize=fs*0.75)
sf()

# <-> d
k3=1.2
ax.plot([xs,xs],[ys, -yi*k3],'k--',lw=lw/2)
ax.annotate(s='', xy=(-d, h*k3), xytext=(0, h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(xs/2, ys*k3+l/20, '$d$', ha='center', va='bottom')
sf()
# <-> F
k3*=G
ax.annotate(s='', xy=(0, -h*k3), xytext=(F*1.05, -h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(F/2, -h*k3-l/20, '$F$', ha='center', va='top')
sf()

# Расчёт коэф. наклона k
k=ys/xs
x=[1.0*xs,  2*xi]
y=[k*x[0],  k*x[1]]

# Луч параллельный из источника
ax.plot([xs,0], [ys,ys], c='tab:blue', lw=lw)
sf()
# Луч преломлённый в изображение (был || ГОО)
dy = yi-ys
dx = xi
k  = dy/dx
b  = ys
x  = [0, 1.5*xi]
y  = [k*x[0]+b,  k*x[1]+b]
ax.plot(x,y, c='tab:blue', lw=lw)
sf()
# Луч через центр
dy = yi-ys
dx = xs-xi
k  = -dy/dx
b  = 0
x  = [xs, 1.5*xi]
y  = [k*x[0]+b,  k*x[1]+b]
ax.plot(x,y, c='tab:blue', lw=lw)
sf()

# Изображение
yi = k*xi
ax.arrow(f, 0, 0, -h*G, fc='tab:orange', ec='tab:orange', head_width=hw*G, head_length=hl*G, length_includes_head=True, lw=lw)
ax.text(f+l/20, -h*G/2, '$h^\prime$', ha='left', va='center_baseline')
sf()
# <-> f
k3=1.2
ax.plot([xi,xi],[0, -yi*k3],'k--',lw=lw/2)
ax.annotate(s='', xy=(0, h*k3), xytext=(f, h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(xi/2, ys*k3+l/20, '$f$', ha='center', va='bottom')
sf()
# <-> f-F
k3*=G
ax.plot([xi,xi],[yi, yi*k3],'k--',lw=lw/2)
ax.annotate(s='', xy=(F, -h*k3), xytext=(f*1.00, -h*k3), arrowprops=dict(arrowstyle='<->'))
ax.text(f*0.6, -h*k3-l/20, '$f-F$', ha='left', va='top')
sf()
### Луч параллельный из изображения
##ax.plot([xi,0], [yi,yi], c='tab:orange', ls='--', lw=lw)
##sf()
### Луч преломлённый в источник (был || ГОО)
##dy = ys-yi
##dx = xs
##k  = dy/dx
##b  = yi
##x  = [0,         1.5*xs]
##y  = [k*x[0]+b,  k*x[1]+b]
##ax.plot(x,y, c='tab:orange', ls='--', lw=lw)
##sf()

# fill_between Предмет-Линза
x=[xs,      0]
y=[k*x[0],  k*x[1]]
ax.fill_between(x, y, fc='none', ec='tab:gray', hatch='///',zorder=0)
sf()
# fill_between Линза-Изображение
x=[0,      xi]
y=[k*x[0],  k*x[1]]
ax.fill_between(x, y, fc='none', ec='tab:gray', hatch='///')
sf()

# fill_between Линза-Изображение II
dy = h+h*G
dx = f
k  = -dy/dx
b  = h
x=[F,         f]
y=[k*x[0]+b,  k*x[1]+b]
ax.fill_between(x, y, fc='none', ec='tab:gray', hatch='\\\\\\')
sf()
x=[0,         F]
y=[k*x[0]+b,  k*x[1]+b]
ax.fill_between(x, y, fc='none', ec='tab:gray', hatch='xxx', zorder=-5)
sf()

## animation
#os.system('convert -delay 10 -loop 0 *.png animated.gif')
    

plt.show()
